﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading;
using System.Workflow.Runtime;
using System.Workflow.Runtime.Hosting;

namespace MultiRuntime
{
    class Program
    {
        static void Main(string[] args)
        {
			/* First instance of the workflow runtime. */
        	WorkflowRuntime workflowRuntime1 = new WorkflowRuntime();

            AutoResetEvent waitHandle = new AutoResetEvent(false);
            workflowRuntime1.WorkflowCompleted 
				+= ((sender, e) => Console.WriteLine("Workflow 1 completed."));
            workflowRuntime1.WorkflowTerminated 
				+= ((sender, e) => Console.WriteLine(e.Exception.Message));

			var parameters = new Dictionary<string, object> {{"Identifier", "Workflow 1"}};
			WorkflowInstance instance1 = workflowRuntime1.CreateWorkflow(
				typeof(MultiRuntime.Workflow1), parameters);
            instance1.Start();

			/* Second instance of the workflow runtime. */
			WorkflowRuntime workflowRuntime2 = new WorkflowRuntime();

			workflowRuntime2.WorkflowCompleted += delegate
			{
				Console.WriteLine("Workflow 2 completed.");
				waitHandle.Set();
			};
			workflowRuntime2.WorkflowTerminated += delegate(
				object sender, WorkflowTerminatedEventArgs e)
			{
				Console.WriteLine(e.Exception.Message);
				waitHandle.Set();
			};

			parameters = new Dictionary<string, object> { { "Identifier", "Workflow 2" } };
			WorkflowInstance instance2 = workflowRuntime2.CreateWorkflow(
				typeof(MultiRuntime.Workflow1), parameters);
			instance2.Start();


            waitHandle.WaitOne();
        	Console.ReadKey();

			workflowRuntime1.Dispose();
			workflowRuntime2.Dispose();
        }
    }
}
